void fileSelected(File selection) {
  //Taken from Processing examples, added a switch() to support future actions
  if (selection == null) {
    println("Window was closed or the user hit cancel.");
  } 
  else 
  {
    println("User selected " + selection.getAbsolutePath());
    SelectedFile = selection.getAbsolutePath();

    String[] WorkStringA = split(SelectedFile, char(92)); //split up by backslash
    SelectedFile = WorkStringA[WorkStringA.length-1]; //get just the filename and extension

    String[] WorkString = new String[10]; //used to divide the lines into tab
    WorkString = split(SelectedFile, '.'); //strip off file extension so it can be added later
    WorkString[1].toLowerCase();

    switch(LoadFileMethod)
    {
    case 0:
      if (FeedFlag == true) //A
      {
        QuickFeeds[FeedASelQuick].FileName = SelectedFile.toLowerCase();

        if (WorkString[1].equals("dat")) QuickFeeds[FeedASelQuick].Method = 3; //set to 3 if loaded file was a .dat
        else if (WorkString[1].equals("png") || WorkString[1].equals("jpg")) QuickFeeds[FeedASelQuick].Method = 2; 
        else QuickFeeds[FeedASelQuick].Method = 0;  //otherwise it is considered a Movie(even images), so set it to 0   

          LoadQuickFeed(myMovieA, QuickFeeds[FeedASelQuick]);
      }
      else
      {
        QuickFeeds[FeedBSelQuick].FileName = SelectedFile.toLowerCase(); 

        if (WorkString[1].equals("dat")) QuickFeeds[FeedBSelQuick].Method = 3; //set to 100 if loaded file was a .dat
        else if (WorkString[1].equals("png") || WorkString[1].equals("jpg")) QuickFeeds[FeedBSelQuick].Method = 2; 
        else QuickFeeds[FeedBSelQuick].Method = 0;  //otherwise it is considered a Movie(even images), so set it to 0   

          LoadQuickFeed(myMovieB, QuickFeeds[FeedBSelQuick]);
      }
      break;
    case 1:    //save device config 

    SaveQuickFeedsFile();
      break;
    case 2: //load device config
      OpenMenuID = 0;
      //write the config.ini file with new path
      String[] clines = loadStrings("config.ini"); //load current config for header comments
      clines[1] = "configs/"+WorkString[0]+".txt"; //get absolute path, and add extension back on

      saveStrings("config.ini", clines);     
      stop(); //since it will crash the software anyway, just stop() and reopen
      //     InitializedWindowSize = false;
      //      setup();  
      break;
    }
  }//end else
}//end func

//========================================================================================================

void LoadAutoFile()
{
  SelectedFile = Matrix.matrixAutomaticFileName.toLowerCase();  
  String[] lines = loadStrings(SelectedFile); //divides the lines
  String[] WorkString = new String[12]; //used to divide the lines into tab

  // Line: Fader Position(0=A, 100=B) - Feed ID - QuickFeed Variable - Draw Counts - Blend Mode(0 - 6) - Blend Speed(100 instant, 1+ = increment on dra
  println("LoadAutoFile() , AutoLines="+AutoLines);

  try {
    WorkString = split(lines[AutoLines], '\t');
  }
  catch(Exception e) {
    println("AutoFile Start Over");
    AutoLines = 1;
    WorkString = split(lines[AutoLines], '\t');
  }
  //set starting Mixer Position
  MixerValue = int(WorkString[0]) / 100;
  MainMixerSlider.Value = int(WorkString[0]);

  FeedID = boolean(WorkString[1]);

  //used in final commands
  //if(FeedID == true) FeedASelQuick = int(WorkString[2]);
  //else FeedBSelQuick = int(WorkString[2]);

  DrawCount = int(WorkString[3]);

  //BlendingMode = 
  HandleBlendButtons(int(WorkString[4])); //CHECK THIS FOR SURE
  BlendSpeed = int(WorkString[5]);

  if (FeedID == true) HandleQuickAButtons(int(WorkString[2]));//LoadQuickFeed(myMovieA, QuickFeeds[FeedASelQuick]);
  else HandleQuickBButtons(int(WorkString[2]));  //LoadQuickFeed(myMovieB, QuickFeeds[FeedBSelQuick]);
} //end func

//==================================================================================================================

void SaveQuickFeedsFile()
{
  //Saves QuickFeed Objects to a txt file using an ArrayList
  SelectedFile = Matrix.matrixQuickFeedFileName;
  String[] WorkString = new String[2]; //used to divide the lines into tab
  WorkString = split(SelectedFile, '.'); //strip off file extension so it can be added later

  SelectedFile = WorkString[0];
  println(SelectedFile); 

  strs = new ArrayList(); // reset array list.... 
  int sLines=0;       
  String BuildLine = "";

  for (int i=0;i != QuickFeeds.length;i++)
  {   
    BuildLine = QuickFeeds[i].UserID+"\t"+QuickFeeds[i].Method+"\t"+QuickFeeds[i].FileName+"\t"+QuickFeeds[i].Speed+"\t"+QuickFeeds[i].SliderRed+"\t"+QuickFeeds[i].SliderGreen
      +"\t"+QuickFeeds[i].SliderBlue+"\t"+QuickFeeds[i].OffsetX+"\t"+QuickFeeds[i].OffsetY+"\t"+QuickFeeds[i].ColorState+"\t"+QuickFeeds[i].ControlState+"\t"+QuickFeeds[i].EffectState
      +"\t"+QuickFeeds[i].ContrastValue+"\t"+QuickFeeds[i].GenSlider1+"\t"+QuickFeeds[i].GenSlider2+"\t"+QuickFeeds[i].GenSlider3+"\t"+QuickFeeds[i].GenSlider4;
    strs.add(BuildLine);
    BuildLine = "";
  }   

  String[] lines = new String[strs.size()]; 

  for (int q=0; q != strs.size();q++)  
  {
    lines[q]=(String) strs.get(q);
  } 

  saveStrings(SelectedFile+".txt", lines);     
  println("File Generated");
}

//================================================================================================================

void LoadQuickFeedsFile()
{
  //Loads data from Quickfeeds file into the objects
  SelectedFile = Matrix.matrixQuickFeedFileName; 
  String[] lines = loadStrings(SelectedFile); //divides the lines
  int sLines=0;  
  String[] WorkString = new String[12]; //used to divide the lines into tab

  for (int i=0; i != QuickFeeds.length;i++)
  {
    try { //try to read the lines of the QuickFeeds file and if there are missing lines or missing file it will recreate them with default
      WorkString = split(lines[i], '\t');
      QuickFeeds[i] = new QuickFeed(WorkString[0], int(WorkString[1]), WorkString[2], float(WorkString[3]), int(WorkString[4]), int(WorkString[5]), 
      int(WorkString[6]), int(WorkString[7]), int(WorkString[8]), int(WorkString[9]), int(WorkString[10]), int(WorkString[11]), int(WorkString[12]), 
      int(WorkString[13]), int(WorkString[14]), int(WorkString[15]), int(WorkString[16]));
    }
    catch(Exception e)
    {
      println("Quick Feed Load Exception, filling with Blank");
      QuickFeeds[i] = new QuickFeed("Exception"+i, 0, "", 1, 255, 255, 255, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
    }
  }//end for

  //try to load thumbnails.dat if its not there, create them, if it is fill PGraphics arrays
  SelectedFile = DeviceFileID+"-thumbnails.dat";  //file name
  int x = 0;
  byte bb[];//create empty byte array  

 println("looking for "+ SelectedFile);
  
  
//  try 
//  {

    //try to loadBytes() if found, it will build new PGraphics arrays containting the thumbnails, if the file is not found
    bb = loadBytes(DeviceFileID+"-thumbnails.dat"); //load the thumbnail data bytes into the byte array
    x = 0;
    for (int q=0; q != cMaxQuickFeeds; q++)
    {
      CachedThumbnails[q] = createGraphics(MatrixWidth, MatrixHeight);
	  
	  CachedThumbnails[q].beginDraw(); //required for Processing 3.0
	  CachedThumbnails[q].endDraw();   //otherwise it errors(NullPointer) on loadPixels()
	  
      CachedThumbnails[q].loadPixels();      

      for (int i = 0; i != (MatrixWidth*MatrixHeight); i++) 
      {
      //  CachedThumbnails[q].pixels[i]=color(int(bb[x]), int(bb[x+1]), int(bb[x+2]));
        x+=3;
      } // end i for()
      CachedThumbnails[q].updatePixels(); 
	  
    }//end q for()
    println("Loaded Thumbnails");
 // }
//  catch(Exception e)
 // {
  
//  println("EXCEPTION REBUILDING THUMBS");
 // 
//   BuildAndSaveThumbnails();
 // }
 
 
 
}//end func

//==========================================================================================

void GeneratePreview(int PassedID)
{
  //uses the methods to run the quickfeed and grab the first frame of a movie/.dat or the 30th iteration of a generated
  int i = PassedID;

  if (QuickFeeds[i].Method == 0) //if any supported video file
  {  
    try {
      PreviewMovie = new Movie(this, Matrix.matrixAbsoluteFootagePath+QuickFeeds[i].FileName);
      PreviewMovie.play(); //start the movie playing
      PreviewMovie.jump(0); //play first frame of movie
      PreviewMovie.pause(); //pause the movie
      //put updated pixels into PGraphics array
      CachedThumbnails[i].beginDraw();
      CachedThumbnails[i].image(PreviewMovie, 0, 0, MatrixHeight, MatrixWidth);
      CachedThumbnails[i].endDraw();

      PreviewMovie.stop();
      PreviewMovie.dispose();
      println("Preview Cached "+QuickFeeds[i].FileName+" : "+i);
    }
    catch(Exception f) {          
      PreviewMovie = new Movie(this, "testbars.png");
      CachedThumbnails[i].beginDraw();
      CachedThumbnails[i].image(PreviewMovie, 0, 0, MatrixHeight, MatrixWidth);
      CachedThumbnails[i].endDraw();  

      PreviewMovie.stop();
      PreviewMovie.dispose();    
      println("Preview Exception");
    }
  }
  else if (QuickFeeds[i].Method == 3) //if .dat file
  {
    println(".dat File Method Preview "+i);
    DataFrameFeedA = 0;
    ByteBufferA = new byte[1]; //shrink just in case
    ByteBufferA = loadBytes(Matrix.matrixAbsoluteFootagePath+QuickFeeds[i].FileName);
    LoadVideoDataFrame(GraphicsBufferA); //Loads first frame of a .dat file

    CachedThumbnails[i].beginDraw();
    CachedThumbnails[i].image(GraphicsBufferA, 0, 0, MatrixHeight, MatrixWidth);
    CachedThumbnails[i].endDraw();
  }
  else
  {
    //else it can be created through the DrawGenerated() function
    println("Generated Preview "+i+" : Method:"+QuickFeeds[i].Method);

    FrameFirstRunB = true;    //made B instead of A because of below line......
    FrameMethodB = QuickFeeds[i].Method; //set MethodB because of the if/else

    for (int q = 0; q != 30;q++) //run for 30 frames
    {
      DisplayThumbnail = i; //used for something else, but will work as a temp register for here
      DrawGenerated(CachedThumbnails[i]); //run the Generated Quickfeed 30 times so the thumbnail is accurate
    }
  } //end else
} //end func

//=================================================================================================================

void BuildAndSaveThumbnails()
{
  //Builds thumbnail .dat files and saves it
  SelectedFile = DeviceFileID+"thumbnails.dat";  //file name
  int x = 0;
  byte bb[];//create empty byte array  
  
   //thumbnails.dat file not found, so create a new one
    for (int i=0; i != QuickFeeds.length;i++)  //generate Thumbnails, that are full size not pixel amount
    {
      CachedThumbnails[i] = createGraphics(MatrixWidth, MatrixHeight);
      GeneratePreview(i);//Generate the Preview Function
    } //end for()

    //save the thumnail preview 
    x = 0;
    bb = new byte[MaxChannels*cMaxQuickFeeds];

    for (int q=0; q != cMaxQuickFeeds; q++)
    {
      CachedThumbnails[q].loadPixels();

      for (int i = 0; i != (MatrixHeight * MatrixWidth); i++) 
      {
        myColor = CachedThumbnails[q].pixels[i];
        myRed = myColor >> 16 & 0xFF; //convert colors to 8-bit
        myGreen = myColor >> 8 & 0xFF;
        myBlue = myColor & 0xFF;   

        bb[x] = byte(int(myRed));
        x++;
        bb[x] = byte(int(myGreen));  
        x++;
        bb[x] = byte(int(myBlue));  
        x++;
      } // end i for()
      CachedThumbnails[q].updatePixels(); //need this???
    }//end q for()   

    saveBytes(DeviceFileID+"-thumbnails.dat", bb);
    println("Thumbnails .dat file saved");
    }//end func()

//=================================================================================================================

void LoadConfigFile()
{
   //loads config.ini to get the path to the device configuration file, each matrix will most likley require their own device config file 
  println("LoadConfigFile()");
  
  Matrix = new MatrixObj();
  
  SelectedFile = "config.ini";  //load the file that holds the path to the device config file

  String[] clines = loadStrings(SelectedFile); //divides the lines
  int sLines = 1;  
  String[] WorkString = new String[15]; //used to divide the lines into tab

  SelectedFile = clines[1]; //now SelectedFile holds the path to the device config file
  DeviceFileID = split(SelectedFile, '.')[0]; //save it for use with thumbnails, strip of extension
  String[] lines = loadStrings(SelectedFile); //divides the lines

  
 //printArray(lines); 
  
//start reading file
  WorkString = split(lines[sLines], '\t');
  Matrix.matrixCOM1 = int(WorkString[1]);
  sLines++;

  WorkString = split(lines[sLines], '\t');
  Matrix.matrixTXBaud = int(WorkString[1]);
  sLines++;

  WorkString = split(lines[sLines], '\t');
  Matrix.matrixWidth  = int(WorkString[1]);
  MatrixWidth = Matrix.matrixWidth;
  sLines++;

  WorkString = split(lines[sLines], '\t');
  Matrix.matrixHeight = int(WorkString[1]);
  MatrixHeight = Matrix.matrixHeight;
  sLines++;

  WorkString = split(lines[sLines], '\t');
  Matrix.matrixPixelDataType  = int(WorkString[1]);
   println("Matrix.matrixPixelDataType:"+Matrix.matrixPixelDataType); 
  sLines++; 
  
  
  WorkString = split(lines[sLines], '\t');
  Matrix.matrixCommMethod = 1;//int(WorkString[1]);
  
  println("Matrix.matrixCommMethod:"+Matrix.matrixCommMethod);
  sLines++;

  WorkString = split(lines[sLines], '\t');
  Matrix.matrixServerIP = WorkString[1];
  sLines++; 

  WorkString = split(lines[sLines], '\t');
  Matrix.matrixServerPort = int(WorkString[1]);
  sLines++;

  WorkString = split(lines[sLines], '\t');
  Matrix.softwareAuroraCMD = boolean(WorkString[1]);
  sLines++;  
  
 //end hardware, start software configs for hardware 
  
  WorkString = split(lines[sLines], '\t');
  Matrix.matrixPatchFileName  = WorkString[1];
  sLines++;

  WorkString = split(lines[sLines], '\t');
  Matrix.matrixQuickFeedFileName = WorkString[1];
  sLines++;

  WorkString = split(lines[sLines], '\t');
  Matrix.matrixAbsoluteFootagePath = WorkString[1];
  sLines++;

  WorkString = split(lines[sLines], '\t');
  Matrix.matrixAutomaticFileName = WorkString[1];
  sLines++;
 
//start software  
  
  WorkString = split(lines[sLines], '\t');
  Matrix.softwareFrameRate = int(WorkString[1]);
  sLines++;
  
  WorkString = split(lines[sLines], '\t');
  int TempW = int(WorkString[1]);
  sLines++;
  WorkString = split(lines[sLines], '\t');
  int TempH = int(WorkString[1]);
  sLines++;
  surface.setSize(TempW, TempH); //no need to place into object
 
  
//end gui setup, setup software control communication
  WorkString = split(lines[sLines], '\t');
  Matrix.softwareMIDIenable = boolean(WorkString[1]);
  sLines++;

  WorkString = split(lines[sLines], '\t');
  Matrix.softwareMIDIport = int(WorkString[1]);
  sLines++;

  WorkString = split(lines[sLines], '\t');
  Matrix.softwareSerialConEnable = boolean(WorkString[1]);
  sLines++;

  WorkString = split(lines[sLines], '\t');
  Matrix.softwareSerialConPort = int(WorkString[1]);
  sLines++;

  WorkString = split(lines[sLines], '\t');
  Matrix.softwareSerialConBaud = int(WorkString[1]);
  sLines++; 
  
//end software control, setup gui functionality  
  
  WorkString = split(lines[sLines], '\t');
  Matrix.softwareEnableDSVideoFeed = boolean(WorkString[1]);
  sLines++;

  WorkString = split(lines[sLines], '\t');
  Matrix.softwareEnableThumbnails = boolean(WorkString[1]);
  sLines++;  

  WorkString = split(lines[sLines], '\t');
  Matrix.softwareLrgPreviewEnable = boolean(WorkString[1]);
  sLines++; 
  
  SF = (float)width / 800; //set scale factor
}


//======================================================================================================

void BuildCustom()
{
  //loads a coordinate patch file, find min and mix point in both directions and scales the overall size to fit within the preview areas
  // creates the Pixel objects to display during draw and fills the Coordinate Arrays for Pixel Patching
  println("BuildCustom()");

  String[] lines = loadStrings(Matrix.matrixPatchFileName); //divides the lines
  int sLines=0;  
  String[] WorkString = new String[3]; //used to divide the lines into tab

  WorkString = split(lines[0], '\t');

  MaxPixels = int(WorkString[0]);
  
  int tempTransArraySize = 0;

  switch(Matrix.matrixPixelDataType)
  {
  case 0: //RGB
  case 2:
  case 3:
  case 4:
  case 5:
  case 6:
    PatchedChannels = MaxPixels *3; //not the same as MaxChannels, incase of non-square matrixes
    MaxChannels = (MatrixWidth * MatrixHeight) * 3;
    tempTransArraySize = PatchedChannels;
    break;
    
  case 1: //RGBW
    PatchedChannels = MaxPixels *4; //not the same as MaxChannels, incase of non-square matrixes
    MaxChannels = (MatrixWidth * MatrixHeight) * 4;
    tempTransArraySize = PatchedChannels;
    break;

  case 7: //Single Color, color used is dealt with later
  case 8:
  case 9:
    PatchedChannels = MaxPixels * 3; //not the same as MaxChannels, incase of non-square matrixes
    MaxChannels = (MatrixWidth * MatrixHeight)*3; //still has 3 channels per pixel to help with compatibility, single channel extratracted in SendData()
    tempTransArraySize = MaxPixels;//(MatrixWidth * MatrixHeight); //single color only one channel per pixel
    break;
  }

  println("PatchedChannels: "+PatchedChannels);
  println("MaxChannels: "+MaxChannels);
  println("MaxPixels: "+MaxPixels); 

  //resizes arrays to match the amount 
  TransmissionArray = new byte[1]; //must resize the Array so it is exactly the same size as channels
  TransmissionArray = expand(TransmissionArray, tempTransArraySize);//PatchedChannels);

  BufferA = new int[1]; //must resize the Array so it is exactly the same size as channels
  BufferA = expand(BufferA, PatchedChannels);

  BufferB = new int[1]; //must resize the Array so it is exactly the same size as channels
  BufferB = expand(BufferB, PatchedChannels);

  MixedBuffer = new int[1]; //must resize the Array so it is exactly the same size as channels
  MixedBuffer = expand(MixedBuffer, PatchedChannels);

//added 2b
  PrevBufferA = new int[1]; //must resize the Array so it is exactly the same size as channels
  PrevBufferA = expand(PrevBufferA, PatchedChannels);
  PrevBufferB = new int[1]; //must resize the Array so it is exactly the same size as channels
  PrevBufferB = expand(PrevBufferB, PatchedChannels);
  
  int MinX=1000;
  int MinY=1000;
  int MaxX=0;
  int MaxY=0;

  for (int i=1;i != lines.length;i++)
  {
    WorkString = split(lines[i], '\t');
    if (int(WorkString[0]) > MaxX) MaxX = int(WorkString[0]);
    if (int(WorkString[0]) < MinX) MinX = int(WorkString[0]);

    if (int(WorkString[1]) > MaxY) MaxY = int(WorkString[1]);
    if (int(WorkString[1]) < MinY) MinY = int(WorkString[1]);
  }
  // println("X: "+MinX+" : "+MaxX);
  // println("Y: "+MinY+" : "+MaxY);

  Xdifference = MaxX - MinX;
  Ydifference = MaxY - MinY;
  println(Xdifference+" : "+Ydifference);

  PatchCoordX = new int[PatchedChannels]; //resize the patch arrays based on PatchedChannels
  PatchCoordY = new int[PatchedChannels];

  //file created was incremented method channel numbers
  for (int i=0;i != MaxPixels;i++)
  {
    WorkString = split(lines[i+1], '\t');      
    PatchCoordX[i] = int(WorkString[0]) - MinX;
    PatchCoordY[i] = int(WorkString[1]) - MinY;
  }

  //int LargestCoord = (MaxX > MaxY) ? MaxX : MaxY;// figure which direction is largest to create the scale val

  int LargestCoord;
  int BaseSize;

  if (MaxX > MaxY)
  {
    LargestCoord = MaxX;
    BaseSize = 240 / LargestCoord; //can't be 0, right?
  }
  else
  {
    LargestCoord = MaxY;
    BaseSize = 210 / LargestCoord; //can't be 0, right?
  }

  int YCenter = floor((220 - (BaseSize * MaxY)) / 2);
  int XCenter = floor((250 - (BaseSize * MaxX)) / 2);  

  for (int i=0; i != MaxPixels;i++)
  { 
    FeedAPixels[i] = new PixelDisplay((5+(PatchCoordX[i]*BaseSize)+XCenter), (10+(PatchCoordY[i]*BaseSize)+YCenter), BaseSize, BaseSize);
    FeedBPixels[i] = new PixelDisplay((535+(PatchCoordX[i]*BaseSize)+XCenter), (10+(PatchCoordY[i]*BaseSize)+YCenter), BaseSize, BaseSize);
    MixedPixels[i] = new PixelDisplay((270+(PatchCoordX[i]*BaseSize)+XCenter), (10+(PatchCoordY[i]*BaseSize)+YCenter), BaseSize, BaseSize);
  }
}//end func