class ggObjAudioCircles
{
	String ggName;
	int ggIDnumber;
	PGraphics selBuffer;
	//added for this gen method

	void ggObjAudioCircles()
	{
		ggName = "Audio Reactive Circles"; //force name
		ggIDnumber = 200;
	}

	void ggInitilaize(PGraphics passedBuf)
	{
		selBuffer = passedBuf;
		SetGenSliderText(cNotUsedLabels, passedBuf);
	
		selBuffer.noStroke();
		selBuffer.fill(255, 0, 0, 0);
		selBuffer.stroke(255);
		selBuffer.strokeWeight(1);
		selBuffer.ellipseMode(CENTER);	
	} //end ggInitilaize()


	void ggFillBuffer()
	{
		//some defaults
		selBuffer.beginDraw();
		selBuffer.colorMode(RGB, 255); //required or wierd things happen
		selBuffer.rectMode(CORNER);       
		selBuffer.strokeWeight(1);
		//end defaults
		
		selBuffer.background(0);
		selBuffer.noFill();
		selBuffer.strokeWeight(1);
		selBuffer.stroke(255);
		for (int i = 0; i < AudioIn.bufferSize() - 1; i=i+(AudioIn.bufferSize()/11))
		{  
			selBuffer.ellipse(round(MatrixWidth/2), round(MatrixHeight/2), 1+(AudioIn.left.get(i)*35), 1+(AudioIn.right.get(i)*35));
		}		

		selBuffer.endDraw();	
	} //end ggFillBuffer()
} //end genGraphicText

//=============================================================================================================

class ggObjAudioSine
{
	String ggName;
	int ggIDnumber;
	PGraphics selBuffer;
	//added for this gen method
	float FadeOutFactor;
	float[] AverageByte = new float[512]; //sine wave


	void ggObjAudioSine()
	{
		ggName = "Audio Reactive Sine Wave"; //force name
		ggIDnumber = 201;
	}

	void ggInitilaize(PGraphics passedBuf)
	{
		selBuffer = passedBuf;
		SetGenSliderText(cSineWave, passedBuf);
	
		selBuffer.noStroke();    
		selBuffer.fill(255);       	
	} //end ggInitilaize()


	void ggFillBuffer()
	{
		//some defaults
		selBuffer.beginDraw();
		selBuffer.colorMode(RGB, 255); //required or wierd things happen
		selBuffer.rectMode(CORNER);       
		selBuffer.strokeWeight(1);
		//end defaults
		
		FadeOutFactor =  (float)HoldGenSlider2 / 255; //Decay

		if (HoldGenSlider3 == 0) selBuffer.background(0); 
		else  DecayBuffer(FadeOutFactor, selBuffer); //run Decay Function
		
		selBuffer.noStroke();
		selBuffer.fill(255);
		
		//standard Sine  wave
		int xx = 0;
		for (int i = 0; i < AudioIn.bufferSize() - 1; i=i+(AudioIn.bufferSize()/MatrixWidth))
		{  
			AverageByte[i]  = (AverageByte[i] + AudioIn.left.get(i));
			selBuffer.rect(xx, (MatrixHeight/2), (HoldGenSlider3/16), round(1+(AudioIn.left.get(i)*(HoldGenSlider1/2))));
			xx++;
		}
	
		selBuffer.endDraw();	
	} //end ggFillBuffer()
} //end genGraphicText

//=============================================================================================================

class ggObjAudioBars
{
	String ggName;
	int ggIDnumber;
	PGraphics selBuffer;
	//added for this gen method
	float FadeOutFactor;
	float[] AverageByte = new float[512]; //sine wave
		
	void ggObjAudioBars()
	{
		ggName = "Audio Reactive Bars"; //force name
		ggIDnumber = 202;
	}

	void ggInitilaize(PGraphics passedBuf)
	{
		selBuffer = passedBuf;
		SetGenSliderText(cReactiveBars, passedBuf);
	
		selBuffer.background(0);
		selBuffer.noStroke();
		selBuffer.fill(255);  	
	} //end ggInitilaize()


	void ggFillBuffer()
	{
		//some defaults
		selBuffer.beginDraw();
		selBuffer.colorMode(RGB, 255); //required or wierd things happen
		selBuffer.rectMode(CORNER);       
		selBuffer.strokeWeight(1);
		//end defaults
		
		FadeOutFactor = (float)HoldGenSlider3 / 255; //Decay

		if (HoldGenSlider3 == 0) selBuffer.background(0); 
		else   DecayBuffer(FadeOutFactor, selBuffer); //run Decay Function

		selBuffer.fill(255);

		int xy = 0;
		for (int i = 0; i < AudioIn.bufferSize() - 1; i=i+(AudioIn.bufferSize()/MatrixWidth))
		{  
			AverageByte[i]  = ((AverageByte[i] * -1) + AudioIn.left.get(i)) / 2;    //was 2
			selBuffer.rect(0+((HoldGenSlider4/16)*xy), MatrixHeight, (HoldGenSlider2/16), 1+(AverageByte[i]*(HoldGenSlider1*3))); //was 25
			xy++;
		} 
			
		selBuffer.endDraw();	
	} //end ggFillBuffer()
} //end genGraphicText

//=============================================================================================================